"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const build_store_1 = __importDefault(require("@ray-core/build-store"));
const shared_1 = require("@ray-core/shared");
const lifecycleEvents = ['onPageScroll', 'onShareAppMessage', 'onShareTimeline'];
exports.default = (options) => {
    let skip = false;
    return {
        pre(state) {
            const importer = (0, shared_1.slash)(state.opts.filename);
            skip = !options.test(importer);
            if (skip) {
                return;
            }
            build_store_1.default.pageEvents.delete(importer);
        },
        visitor: {
            StringLiteral: (path, state) => {
                var _a, _b;
                if (skip) {
                    return;
                }
                const { node } = path;
                const importer = (0, shared_1.slash)(state.file.opts.filename);
                // ['onPageScroll', 'onShareAppMessage', 'onShareTimeline']
                // 非这3个事件，不添加到运行时
                if (!lifecycleEvents.includes(node.value)) {
                    return;
                }
                build_store_1.default.pageEvents.set(importer, (_b = (_a = build_store_1.default.pageEvents.get(importer)) === null || _a === void 0 ? void 0 : _a.add(node.value)) !== null && _b !== void 0 ? _b : new Set([node.value]));
            },
            Identifier: (path, state) => {
                var _a, _b;
                if (skip) {
                    return;
                }
                const { node } = path;
                const importer = (0, shared_1.slash)(state.file.opts.filename);
                // ['onPageScroll', 'onShareAppMessage', 'onShareTimeline']
                // 非这3个事件，不添加到运行时
                if (!lifecycleEvents.includes(node.name)) {
                    return;
                }
                build_store_1.default.pageEvents.set(importer, (_b = (_a = build_store_1.default.pageEvents.get(importer)) === null || _a === void 0 ? void 0 : _a.add(node.name)) !== null && _b !== void 0 ? _b : new Set([node.name]));
            },
        },
    };
};
